;;; -*- mode:scheme; coding:utf-8; -*-
;;;
;;; postgresql.sld - PostgreSQL bindings
;;;  
;;;   Copyright (c) 2014-2015  Takashi Kato  <ktakashi@ymail.com>
;;;   
;;;   Redistribution and use in source and binary forms, with or without
;;;   modification, are permitted provided that the following conditions
;;;   are met:
;;;   
;;;   1. Redistributions of source code must retain the above copyright
;;;      notice, this list of conditions and the following disclaimer.
;;;  
;;;   2. Redistributions in binary form must reproduce the above copyright
;;;      notice, this list of conditions and the following disclaimer in the
;;;      documentation and/or other materials provided with the distribution.
;;;  
;;;   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;;;   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;;;   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
;;;   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
;;;   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
;;;   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
;;;   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
;;;   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
;;;   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
;;;   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
;;;   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;;;  

;; forwarding
(define-library (postgresql)
  (import (postgresql apis)
	  (postgresql conditions))
  (export make-postgresql-connection
	  postgresql-connection?
	  postgresql-open-connection!
	  postgresql-secure-connection!
	  postgresql-login!
	  postgresql-terminate!
	  postgresql-query?
	  postgresql-query-descriptions
	  postgresql-execute-sql!
	  postgresql-prepared-statement?
	  postgresql-prepared-statement
	  postgresql-prepared-statement-sql
	  postgresql-bind-parameters!
	  postgresql-execute!
	  postgresql-close-prepared-statement!
	  postgresql-fetch-query!
	  
	  postgresql-start-transaction!
	  postgresql-commit!
	  postgresql-rollback!

	  *postgresql-maximum-results*
	  *postgresql-date-format*
	  *postgresql-time-format*
	  *postgresql-timestamp-format*
	  *postgresql-copy-data-handler*
	  *postgresql-write-data-handler*
	  *postgresql-notice-handler*
	  *postgresql-unknown-type-handler*

	  postgresql-transaction-mode

	  postgresql-isolation-level-serializable
	  postgresql-isolation-level-repeatable-read
	  postgresql-isolation-level-read-committed
	  postgresql-isolation-level-read-uncommitted
	  postgresql-access-mode-read-write
	  postgresql-access-mode-read-only
	  postgresql-deferrable-on
	  postgresql-deferrable-off

	  postgresql-error?
	  postgresql-error-severity
	  postgresql-error-code
	  postgresql-error-schema
	  postgresql-error-table
	  postgresql-error-column
	  postgresql-error-data-type
	  postgresql-error-constraint
	  ))
